; Copyright (c) 1991, Louis Marienthal, All Rights Reserved

      ;    1  descctrl                              ---
      ;    2  DescDir                               A28
      ;    3  ProcDir                               A28
      ;    4  LibDir                                A28
      ;    5  SpecDir                               A28
      ;    6  WorkDir                               A28
      ;    7  Table                                 A28
      ;    8  Form                                  A2
      ;    9  Spec                                  A6
      ;   10  Ctrl.f                                A1
      ;   11  Script                                A8
      ;   12  AutoE.f                               A1

;===
PROC Closed UK_MenuTop ()
    ;====================
UseVars AutoLib, descctrl.r, proc.a

WHILE True
    SWITCH
       Case proc.a = "":     UK_Menu ()
       Case proc.a = "quit": QuitLoop
       Otherwise:            ExecProc proc.a
                             Clear Reset
                             View descctrl.r [2] + "descctrl"
                             Release Vars All
                             CopyToArray descctrl.r
                             Reset
                             proc.a = ""
                             AutoLib = descctrl.r [2] + "desc45"
    ENDSWITCH
ENDWHILE

ENDPROC
;======

;===
PROC UK_Menu ()
    ;==========
Private chz.r, xpl.r, maxnode.n, menu.r, lib.a

View descctrl.r [2] + "menu"
End
UK_MenuSet ([Menu_Ref])

WHILE True
   SHOWARRAY chz.r xpl.r DEFAULT chz.r [1] TO chz.a

   IF chz.a = "Esc" THEN
      Locate menu.a, BlankNum ()              ; menu special entry for Esc
   ELSE
      FOR node.s FROM 1 TO maxnode.n
          IF chz.r [node.s] = chz.a THEN
             Locate menu.a, node.s            ; menu entry for other choice
             QuitLoop
          ENDIF
      ENDFOR
   ENDIF

   IF Not RetVal THEN
      UK_Vmsg ("Menu Table Error -- Bad Reference to Menu -- Must Quit")
      UK_Beep ()
      Quit
   ENDIF

   CopyToArray menu.r

   IF Not IsBlank (menu.r [4]) THEN
      UK_MenuSet (menu.r [4])                     ; set up for new menu
      Loop
   ENDIF

   IF IsBlank (menu.r [5]) or IsBlank (menu.r [6]) THEN
      IF Not IsBlank (menu.r [6]) THEN
         proc.a = Lower (menu.r [6])
         IF proc.a = "quit" THEN
            Return
         ENDIF
      ENDIF
      UK_Vmsg ("No Menu Ref and Either Proc or Lib Is Blank -- Must Quit")
      UK_Beep ()
      Quit
   ENDIF

   menu.a = ""
   lib.a =  lower (menu.r [5])
   proc.a = lower (menu.r [6])
   IF Search (lib.a, AutoLib) = 0 THEN
      AutoLib = descctrl.r [2] + lib.a + "," + AutoLib
   ENDIF
   Clear ClearAll
   QuitLoop
ENDWHILE

ENDPROC
;======

;===
PROC UK_MenuSet (m)
    ;==============
Private n, m

menu.a = m
Locate menu.a, 1
IF Not RetVal THEN
   UK_Vmsg ("Bad Menu Reference in Specs-Menu -- Must Quit")
   UK_Beep ()
   Quit
ENDIF
WHILE [Menu] = menu.a
   DOWN
ENDWHILE
UP
maxnode.n = [Node]
DOWN

Array chz.r [maxnode.n]
Array xpl.r [maxnode.n]

FOR n FROM maxnode.n TO 1 STEP -1
   UP
   chz.r [n] = [Chz]
   xpl.r [n] = [Xpl]
ENDFOR

ENDPROC
;======

;===
PROC UK_SpecRpt ()
    ;=============
Private prn.a

Clear
ClearAll
WHILE True
   SHOWMENU
      "Skip":   "SPECIFICATION REPORT: Skip Output and Return to DESC Menu",
      "Print":  "SPECIFICATION REPORT: Send to Printer",
      "View":   "SPECIFICATION REPORT: Send to Screen"
   TO prn.a

   IF prn.a = "Esc" THEN
      Beep
      Loop
   ENDIF
   IF prn.a = "Print" and Not PrinterStatus () THEN
      Beep
      Message "Printer Not Ready" Sleep 2000
      Loop
   ENDIF
   QuitLoop
ENDWHILE

IF prn.a <> "Skip" THEN
   IF prn.a = "Print" THEN
      Report wrktabl.a 1
   ELSE
      {Report} {Output} Select wrktabl.a {1} {Screen}
   ENDIF
ENDIF
Clear ClearAll

ENDPROC
;======

;===
PROC UK_Err ()
    ;=========
Private errorproc

IF IsAssigned (homedir.a) THEN
   SetDir homedir.a
   Message "Directory Set to " + homedir.a
ENDIF
Sleep 2000
Return 2

ENDPROC
;======

;===
PROC UK_GetCtrl (cf.a)
    ;=================

Prompt "Fill in all fields and press F2 when finished",
       "Press Esc to stop job without making specification"
Reset
Clear
Edit descctrl.r [2] + "descctrl"
PickForm cf.a

WHILE true
   WAIT Record UNTIL "F2", "Esc", -24, 15

   IF RetVal = "Esc" THEN
      Message "You Stopped Job" Sleep 2000
      Clear
      Return False
   ENDIF
   IF RetVal = "F2" THEN
      CopyToArray descctrl.r
      err.f = false
      IF cf.a = "1" THEN
         descctrl.r [6] = Directory ()
      ENDIF
      FOR x FROM 2 TO 6
         IF IsBlank (descctrl.r [x]) THEN
            Message "All Fields Are Required" Sleep 2000
            err.f = true
            QuitLoop
         ENDIF
         IF Not Match (descctrl.r [x], "..\\") THEN
            descctrl.r [x] = descctrl.r [x] + "\\"
         ENDIF
         IF DirExists (descctrl.r [x]) = 0 THEN
            Message descctrl.r [x] + " Directory Not Found" Sleep 2000
            err.f = true
            QuitLoop
         ENDIF
         IF DirExists (descctrl.r [x]) = -1 THEN
            Message descctrl.r [x] + " Not Valid Directory Name" Sleep 2000
            err.f = true
            QuitLoop
         ENDIF
      ENDFOR
      IF err.f THEN
         Loop
      ENDIF
      IF cf.a > "1" THEN
         IF IsBlank (descctrl.r [7]) or
            IsBlank (descctrl.r [8]) or
            IsBlank (descctrl.r [9]) THEN
            err.f = true
         ENDIF
      ENDIF
      IF cf.a > "2" THEN
         IF IsBlank (descctrl.r [10]) or
            IsBlank (descctrl.r [12]) THEN
            err.f = true
         ENDIF
      ENDIF
      IF cf.a = "5" and IsBlank (descctrl.r [11]) THEN
         err.f = true
      ENDIF
      IF cf.a = "4" THEN
         descctrl.r [11] = ""
      ENDIF
      IF err.f THEN
         Message "All Fields Are Required" Sleep 2000
         Loop
      ENDIF
      Clear
      CopyFromArray descctrl.r
      DO_IT!
      Return True
   ENDIF
   Beep
ENDWHILE

ENDPROC
;======

;===
PROC UK_DoPath ()
    ;============

UK_GetCtrl ("1")

ENDPROC
;======

;===
PROC UK_DoSpec ()
    ;============

Reset
READLIB descctrl.r [2] + "desc45" UK_Err
ErrorProc = "UK_Err"
UK_GetCtrl ("2")
IF Not RetVal THEN
   Reset
   Return
ENDIF

spectabl.a = descctrl.r [5] + descctrl.r [9]     ;   [Spec]
IF IsTable (spectabl.a) THEN
   Message "Specification Already Exists" Sleep 2000
   Clear
   ClearAll
   WHILE True
      SHOWMENU
         "Cancel":  "Cancel and Return to Desc Utility Menu",
         "Replace": "Delete Existing Table and Replace"
      TO xr.a

      IF xr.a = "Esc" THEN
         Beep
         Loop
      ENDIF
      QuitLoop
   ENDWHILE

   IF xr.a = "Cancel" THEN
      Reset
      Return
   ELSE
      Delete spectabl.a
   ENDIF
ENDIF

homedir.a = Directory ()
SetDir descctrl.r [6]

IF Not IsTable (descctrl.r [7]) THEN
   Message descctrl.r [7] + " Master Table Not Found" Sleep 2000
   IF SubStr (Directory (), 2, 1) = ":" THEN
      SetDir SubStr (Directory (), 1, 2) + "\\"
   ENDIF
   SetDir homedir.a
   Return
ENDIF

frm.a = descctrl.r [8]                     ;  [form]
IF frm.a <> "F" THEN
   frm.a = ".F" + frm.a
ELSE
   frm.a = ".F"
ENDIF
frmpath.a = descctrl.r [7] + frm.a
IF Not IsFile (frmpath.a) THEN
   Message frmpath.a + " File for Form Not Found" Sleep 2000
   IF SubStr (Directory (), 2, 1) = ":" THEN
      SetDir SubStr (Directory (), 1, 2) + "\\"
   ENDIF
   SetDir homedir.a
   Return
ENDIF

IF IsMultiForm (descctrl.r [7], descctrl.r[8]) THEN
   FormTables descctrl.r [7] descctrl.r[8] tlist.r
   z = ArraySize (tlist.r)
   Array flist.r [z + 1]
   flist.r [1] = descctrl.r [7]
   FOR x FROM 1 TO z
      flist.r [x + 1] = tlist.r [x]
   ENDFOR
ELSE
   Array flist.r [1]
   flist.r [1] = descctrl.r [7]
ENDIF

basetabl.a = descctrl.r [2] + "fields"
Empty basetabl.a
Copy basetabl.a spectabl.a

ClearAll
FOR a FROM 1 TO ArraySize (flist.r)
    {Ask} Select flist.r [a]
    z = NFields (flist.r [a])
    Array F [z]
    Array G [z]
    FOR b FROM 1 TO z
        Right
        F [b] = Field ()
        G [b] = FieldType ()
    ENDFOR
    ClearImage

    CoEdit spectabl.a
    End
    Down
    FOR b FROM 1 TO z
        [Pathname] = flist.r [a]
        IF flist.r [a] = descctrl.r [7] THEN
           [Form] = descctrl.r [8]
        ENDIF
        [F#] = b
        [Field Name] = F [b]
        [Field Type] = G [b]
        Down
    ENDFOR
    DO_IT!
    ClearImage
ENDFOR
IF SubStr (Directory (), 2, 1) = ":" THEN
   SetDir SubStr (Directory (), 1, 2) + "\\"
ENDIF
SetDir homedir.a

EndProc
;======

;===
Proc UK_UseSpec ()
    ;=============
Private vars.a, tempnam.a

Reset
UK_GetCtrl ("4")
IF Not RetVal THEN
   Reset
   Return
ENDIF

tempnam.a = descctrl.r [5] + descctrl.r [9] + "_v.sc"
IF Not IsFile (tempnam.a) THEN
   Beep
   Message tempnam.a + " Script with Variables Not Found" Sleep 2000
   Reset
   Return
ENDIF

descctrl.r [11] = ""     ; blank script name is flag for no app-specific proc
homedir.a = Directory ()
SetDir descctrl.r [6]

xLib.a = Autolib
AutoLib = descctrl.r [2] + "desc123"
UK_Init ()
AutoLib = xLib.a

IF SubStr (Directory (), 2, 1) = ":" THEN
   SetDir SubStr (Directory (), 1, 2) + "\\"
ENDIF
SetDir homedir.a
Reset

EndProc
;======

;===
Proc UK_UseProc ()
    ;=============
Private lib.a, tempnam.a

Reset
UK_GetCtrl ("5")
IF Not RetVal THEN
   Reset
   Return
ENDIF

tempnam.a = descctrl.r [4] + descctrl.r [11] + ".lib"
IF Not IsFile (tempnam.a) THEN
   Beep
   Message tempnam.a + " for Application-Specific Script Not Found" Sleep 2000
   Reset
   Return
ENDIF

homedir.a = Directory ()
SetDir descctrl.r [6]

xLib.a = AutoLib
AutoLib = descctrl.r [2] + "desc123"
UK_Init ()
AutoLib = xLib.a

IF SubStr (Directory (), 2, 1) = ":" THEN
   SetDir SubStr (Directory (), 1, 2) + "\\"
ENDIF
SetDir homedir.a
Reset

EndProc
;======

;===
PROC UK_EditSpec ()
    ;==============

Reset
READLIB descctrl.r [2] + "desc45" UK_Err
ErrorProc = "UK_Err"
UK_GetCtrl ("4")
IF Not RetVal THEN
   Reset
   Return
ENDIF

spectabl.a = descctrl.r [5] + descctrl.r [9]
IF Not IsTable (spectabl.a) THEN
   Beep
   Message spectabl.a + " Specification Table Not Found" Sleep 2000
   Reset
   Return
ENDIF

wrktabl.a = descctrl.r [2] + "Fields"
Empty wrktabl.a
Add spectabl.a wrktabl.a

descctrl.r [4] = descctrl.r [2]
descctrl.r [5] = descctrl.r [2]
descctrl.r [9] = "fld"
descctrl.r [11] = "kbfld"

Reset
xLib.a = AutoLib
AutoLib = descctrl.r [2] + descctrl.r [11] + ","
        + descctrl.r [2] + "desc123"
UK_Init ()
AutoLib = xLib.a
Reset

Empty spectabl.a
Add wrktabl.a spectabl.a
UK_PosChk ()

{Ask} Select wrktabl.a
   "delete"
   [Pos] = "blank"
   DO_IT!
UK_SpecRpt ()
Empty wrktabl.a

ENDPROC
;======

;===
PROC UK_PosChk ()
    ;============

calc1 = CMax (spectabl.a,"pos")
calc2 = CCount (spectabl.a,"pos")
IF calc1 = "Error" or calc2 = "Error" THEN
   Message "Error in Spec Table -- No Pos Numbers Assigned"
   Sleep 2000
   Return false
ENDIF
IF calc1 <> calc2 THEN
   Message "Maximum Pos Number: " + StrVal (calc1) +
           " Not Equal Count of Pos Numbers: " + StrVal (calc2)
   Sleep 2000
   Return false
ENDIF
ClearAll
{Ask} Select spectabl.a
[Pos] = "calc count as x"
DO_IT!
calc3 = [x]
ClearAll
IF calc2 <> calc3 THEN
   Message "Count of Pos Numbers: " + StrVal (calc2) +
           " Not Equal Number of Different Pos Numbers: " + StrVal (calc3)
   Sleep 2000
   Return false
ENDIF
Return true

ENDPROC
;======
